/**
 * Clase Empleado
 * Guarda informacin sobre un empleado
 **/
abstract class Empleado{ 
	protected long idEmpleado = 0;
	protected String nombre = "SinNombre";
	protected double sueldo = 0;
   
	static int numEmpleados = 0;
   
	/**
	 * Crea un nuevo empleado vaco
	 **/
	Empleado(){
		numEmpleados++;
	}
	/**
	 * Crea un nuevo empleado con un id
	 **/   
	Empleado(long id){
		this();
		idEmpleado = id;
	}
	/**
	 * Crea un nuevo empleado con id y con nombre
	 **/
	Empleado(long id, String nombre){
		this(id);
		this.nombre = nombre;
	}
     
	/**
	 *Mtodos ayudantes
	 **/
	
	long getIdEmpleado(){
		return idEmpleado;
	}
	
	String getNombre(){
    	return(nombre);
	}
	
	double getSueldo(){
		return sueldo;
	}
	
	void setIdEmpleado(long id){
		idEmpleado = id;
	}
	
	void setNombre(String nom){
		nombre = nom;
	}
	
	void setSueldo(double s){
		sueldo = s;
	}
	/**
	 * Devuelve el empleado en el formato:
	 * (idEmpleado) Nombre Sueldo: sueldo
	 **/	
	public String toString(){
    	return "Id. Empleado: " + idEmpleado + 
    	       "\nNombre: " + nombre + 
    	       "\nSueldo: " + sueldo;
	}
	/**
	 * Dos empleados son iguales si tienen el mismo id
	 **/
	public boolean equals(Empleado e){
    	return idEmpleado == e.idEmpleado;
	}
	/**
	 * Aumenta el sueldo un tanto por ciento
	 **/
	void aumentarSueldo(float porCiento){
    	this.sueldo = (this.sueldo * porCiento / 100) + this.sueldo;
	}
	/**
	 * Aumenta el sueldo una cantidad determinada de euros
	 **/   
  	void aumentarSueldo(double euros){
  		this.sueldo +=euros;
	}
   
  	/**
  	 * Obtiene el nmero de empleados instanciados
  	 **/
  	static int cuantosEmpleados(){
    	return numEmpleados;
	}
      
   abstract void calcularSueldo();
	

}